// Jean Luc Biellmann - contact@alsatux.com - 2013

var _XML2C = {

	info: function (id,mess) {
		var div = document.getElementById(id);
		div.innerHTML = mess;
	},

	ls: function () {
		var select = document.getElementById('sel1');
		select.innerHTML = '';		
		var medium = navigator.getDeviceStorage('sdcard');
		var cursor = medium.enumerate('contacts2xml');
		cursor.onsuccess = function () {
			var file = this.result;
			if (file != null) {
				var re = new RegExp('^.*contacts2xml\/([0-9]{14}).xml$','');
				var m = (file.name).match(re);
				if (m) {
					var opt = new Option(m[1],file.name);
					//console.log(file.name);
					select.appendChild(opt);
				}
				this.done = false;
			} else {
				this.done = true;
			}
			//console.log(select.options.length);
			if (!this.done) {
				this.continue();
			}
		}
		cursor.onerror = function () {
			alert('No sdcard/contacts2xml found or no backup available ! Use Contacts2XML to export your contacts to SD-Card first !');
		}
		return true;
	},

	clearAll: function () {
		if (confirm('Delete all contacts ? (no way back !)')) {
			document.getElementById('chooser').style.display = 'none';
			document.getElementById('restoring').style.display = 'none';
			var req = window.navigator.mozContacts.clear();
			req.onsuccess = function () {
				alert("Contacts removed !");
				document.getElementById('chooser').style.display = '';
				document.getElementById('restoring').style.display = 'none';
			};
			req.onerror = function () {
				alert("Removing all contacts failed.");
				document.getElementById('chooser').style.display = '';
				document.getElementById('restoring').style.display = 'none';
			};
		}
	},

	add: function (person) {
		//console.debug(person);
		var req = window.navigator.mozContacts.save(person);
		req.onsuccess = function () {
			console.log('New contact saved ! (' + person.id + ')');
			person = req.result;
		}
		req.onerror = function () {
			console.log("Error adding contact.");
		}
	},

	restore: function () {
		var select = document.getElementById('sel1');
		var index = select.options.selectedIndex;
		if (index!=-1) {
			var file = select.options[index].value;
			var medium = navigator.getDeviceStorage('sdcard');
			var req = medium.get(file);			
			document.getElementById('chooser').style.display = 'none';
			document.getElementById('restoring').style.display = '';
			req.onsuccess = function () {
				var file = this.result;
				var reader = new FileReader();
				reader.onload = function(e) {
					var text = (reader.result).replace('<?xml version="1.0" encoding="UTF-8"?>','');
					var parser = new DOMParser(); 
					var xml_doc = parser.parseFromString(text,"text/xml");
					_XML2C.read(xml_doc);
				}
				reader.readAsText(file, 'UTF-8');				
				document.getElementById('chooser').style.display = '';
				document.getElementById('restoring').style.display = 'none';
			}			
			req.onerror = function () {
				alert("Unable to get the file: " + this.error);
				document.getElementById('chooser').style.display = '';
				document.getElementById('restoring').style.display = 'none';
			}			
		} else {
			alert('No file selected !');
		}
	},	
		
	read: function (xml_doc) {
		var contacts = xml_doc.getElementsByTagName('contact');
		var count = 0;
		// alert('restoring ' + contacts.length + ' contacts !');
		for (var i=0;i<contacts.length;i++) {
			// console.debug(contacts[i]);
			var json = _XML2C.xml2json(contacts[i]);
			console.log('json = ' + json);
			var person = new mozContact();
			person.init(json);
			_XML2C.add(person);
			count++;
			document.getElementById('count').innerHTML = 'Restoring contact N°' + count;
		}
	},

	xml2json: function (xml) {
		var obj = {}
		console.log('xml = ' + xml);
		if (xml.hasChildNodes()) {
			// debugger;
			for(var i=0; i<xml.childNodes.length; i++) {
				var item = xml.childNodes.item(i);
				console.log('item=' + item);
				var nodeName = item.nodeName;
				console.log('nodeName=' + nodeName);
				if (typeof(nodeName)!='undefined') {
					if (nodeName.match(/(tel|email|url)/)) {
						var child_obj = {};
						for(var j = 0; j<item.childNodes.length; j++) {
							var subitem = item.childNodes.item(j);
							if (subitem.nodeName=='type') {
								if (typeof(child_obj['type'])=='undefined')
									child_obj['type'] = [];
								child_obj['type'].push(subitem.childNodes[0].nodeValue);
							}
							else if (subitem.nodeName=='value')
								child_obj['value'] = subitem.childNodes[0].nodeValue;
						}
						if (child_obj['value']!=undefined && child_obj['value'].length) {
							if (typeof(obj[nodeName])=='undefined')
								obj[nodeName] = [];
							obj[nodeName].push(child_obj);
						}
					}
					else if (nodeName=='adr') {
						var child_obj = {};
						for(var j = 0; j<item.childNodes.length; j++) {
							var subitem = item.childNodes.item(j);
							if (subitem.nodeName=='type') {
								if (typeof(child_obj['type'])=='undefined')
									child_obj['type'] = [];
								child_obj['type'].push(subitem.childNodes[0].nodeValue);
							}
							else if (subitem.nodeName=='pref')
								child_obj['pref'] = subitem.childNodes[0].nodeValue=='true' ? true : false;
							else if (subitem.nodeName.match(/(streetAddress|locality|region|postalCode|countryName)/))
								child_obj[subitem.nodeName] = subitem.childNodes[0].nodeValue;
						}
						if (typeof(obj[nodeName])=='undefined')
							obj[nodeName] = [];
						obj[nodeName].push(child_obj);
					}
					else
					if (nodeName.match(/(name|honorificPrefix|givenName|additionalName|familyName|honorificSuffix|nickname|category|org|jobTitle|note|key)/)) {
						if (typeof(obj[nodeName])=='undefined')
							obj[nodeName] = [];
						obj[nodeName].push(item.childNodes[0].nodeValue);
					}
					else if (nodeName.match(/(sex|genderIdentity)/)) {
						obj[nodeName] = item.childNodes[0].nodeValue;
					}
					else if (nodeName.match(/(bday|anniversary)/)) {
						obj[nodeName] = new Date(item.childNodes[0].nodeValue);
					}
				}
			}
		}
		return obj;
	}

};

window.onload = function () {
	_XML2C.ls();
	var but1 = document.getElementById('but1');
	but1.addEventListener("click", _XML2C.restore);
	var but2 = document.getElementById('but2');
	but2.addEventListener("click", _XML2C.clearAll);
}
